library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Lab 2 CRK for FSM Counter
-- By Seth Marinello

entity Lab2FSM is
   port ( CLK,CLR,UPDOWN,HOLD: in std_logic;
                    SEGMENTS : out std_logic_vector(6 downto 0);
			      DISP_EN : out std_logic_vector(3 downto 0);
			          RCO : out std_logic;
                           Z : out std_logic_vector(1 downto 0));
end Lab2FSM;

architecture struct of Lab2FSM is
-- component declaration --------------------
component FSMCounter
   port ( CLR,CLK,UPDOWN,HOLD: in  std_logic;
                          RCO: out std_logic;
                            Y: out std_logic_vector(3 downto 0);
				        Z: out std_logic_vector(1 downto 0));
end component;
-- component declaration --------------------
component clk_div
    Port (          CLK : in std_logic;
           clk_slow_out : out std_logic;
           clk_fast_out : out std_logic);
end component;
-- component declaration --------------------
component bin_sseg_dec
    Port (       Y : in std_logic_vector(3 downto 0);
               CLK : in std_logic;
           disp_en : out std_logic_vector(3 downto 0);
          segments : out std_logic_vector(6 downto 0));
end component;

-- intermediate signal declaration ----------
signal SLOW_CLK : std_logic;
signal FAST_CLK : std_logic;
signal         Y: std_logic_vector(3 downto 0);

begin
   --Port Mapping -------
   onehotFSM : FSMCounter
   port map (CLK => SLOW_CLK,
             CLR => CLR,
		  HOLD => HOLD,
          UPDOWN => UPDOWN,
		     Z => Z,
		   RCO => RCO,
		     Y => Y);

   clkFun : clk_div
   port map (CLK => CLK,
    clk_slow_out => SLOW_CLK, 
    clk_fast_out => FAST_CLK);

   DEC : bin_sseg_dec
   port map (Y => Y,
           CLK => FAST_CLK,
	  disp_en => DISP_EN,
	 segments => SEGMENTS);
end struct;

